VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBBSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

' VB-CONFIGURATION
Option Compare Binary
Option Explicit
Option Base 0

' CONSTANTS(PRIVATE)
Private Const BABERR = vbError + &HBAB
Private Const VAREMPTY = 0&
Private Const NUL& = 0&


' ENUMERATIONS(PUBLIC)
Private Enum TableType_ENUM
    VT_Double
    VT_String
    VT_Long
    VT_Int
End Enum


' VARIABLES(PRIVATE)
Private dblTableDouble()                    As Double
Private strTableString()                    As String
Private lngTableLong()                      As Long
Private objBBparent                         As clsBBSortContainer
Private intTableInt()                       As Integer
Private enmTableType                        As TableType_ENUM
Private enmSort                             As Sort_ENUM
Private lngSortFrom                         As Long
Private lngSortTo                           As Long
Private lngClassID                          As Long
Private lngCount                            As Long


' PROPERTYS(PUBLIC/FRIEND)
Friend Property Let SortFrom(ByVal plngValue As Long)
    lngSortFrom = plngValue
End Property

Friend Property Let SortTo(ByVal plngValue As Long)
    lngSortTo = plngValue
End Property

Friend Property Get Count() As Long
    Count = lngCount
End Property

Friend Property Let ClassID(ByVal plngValue As Long)
    lngClassID = plngValue
End Property

Friend Property Let SortingStyle(ByVal penmSorting As Sort_ENUM)
    enmSort = penmSorting
End Property

Friend Property Get SortingStyle() As Sort_ENUM
    SortingStyle = enmSort
End Property

Friend Property Set BBparent(ByVal objParent As clsBBSortContainer)
    Set objBBparent = objParent
End Property
Friend Property Get BBparent() As clsBBSortContainer
    Set BBparent = objBBparent
End Property


'FUNCTIONS/SUBS
'PUBLIC

Public Sub Clear()
'Auflsen von Zirkelbezgen
    Set objBBparent = Nothing
    
End Sub

Public Sub Go()
    
    Dim OuterCycle              As Long
    Dim InnerCycle              As Long
    Dim CountEqu                As Long
    Dim a                       As Variant
    Dim b                       As Variant
    
    For OuterCycle = lngSortTo - 1 To lngSortFrom Step -1
        For InnerCycle = lngSortFrom To OuterCycle Step 1
            a = GetValue(InnerCycle)
            b = GetValue(InnerCycle + 1)
            Select Case enmSort
                Case Sort_ENUM.S_Ascending:
                    If a > b Then
                        Call Swap(InnerCycle, InnerCycle + 1)
                        Call objBBparent.DoSwapValue(lngClassID, InnerCycle, InnerCycle + 1)
                    End If
                Case Sort_ENUM.S_descending:
                    If a < b Then
                        Call Swap(InnerCycle, InnerCycle + 1)
                        Call objBBparent.DoSwapValue(lngClassID, InnerCycle, InnerCycle + 1)
                    End If
            End Select
        Next InnerCycle
    Next OuterCycle
    
    For OuterCycle = lngSortFrom To lngSortTo - 1 Step 1
        a = GetValue(OuterCycle)
        b = GetValue(OuterCycle + 1)
        If a = b Then
            CountEqu = CountEqu + 1
        Else
            If CountEqu > 0 Then
                Call objBBparent.DoSort(lngClassID, OuterCycle - CountEqu, OuterCycle)
                CountEqu = 0
            End If
        End If
    Next OuterCycle
    If CountEqu > 0 Then
        Call objBBparent.DoSort(lngClassID, lngSortTo - CountEqu, lngSortTo)
    End If

End Sub

Public Sub Swap(ByVal plngFrom As Long, ByVal plngTo)
    
    Dim DeltaDouble             As Double
    Dim DeltaString             As String
    Dim DeltaLong               As Long
    Dim DeltaInt                As Integer
    
    Select Case enmTableType
        Case TableType_ENUM.VT_Double:
            DeltaDouble = dblTableDouble(plngTo)
            dblTableDouble(plngTo) = dblTableDouble(plngFrom)
            dblTableDouble(plngFrom) = DeltaDouble
        Case TableType_ENUM.VT_String:
            DeltaString = strTableString(plngTo)
            strTableString(plngTo) = strTableString(plngFrom)
            strTableString(plngFrom) = DeltaString
        Case TableType_ENUM.VT_Long:
            DeltaLong = lngTableLong(plngTo)
            lngTableLong(plngTo) = lngTableLong(plngFrom)
            lngTableLong(plngFrom) = DeltaLong
        Case TableType_ENUM.VT_Int:
            DeltaInt = intTableInt(plngTo)
            intTableInt(plngTo) = intTableInt(plngFrom)
            intTableInt(plngFrom) = DeltaInt
    End Select
    
End Sub

Friend Sub SetTableDouble(ByRef pdblTable() As Double)
    Dim x                       As Long
    
    ReDim dblTableDouble(0 To UBound(pdblTable))
    For x = 0 To UBound(dblTableDouble)
        dblTableDouble(x) = pdblTable(x)
    Next x
    dblTableDouble() = pdblTable()
    lngCount = UBound(dblTableDouble) + 1
    enmTableType = VT_Double
End Sub
Friend Function GetTableDouble(ByRef pdblTable() As Double) As Long
    Dim x                       As Long
    
    For x = 0 To UBound(pdblTable)
        pdblTable(x) = dblTableDouble(x)
    Next x
    GetTableDouble = x
End Function

Friend Sub SetTableString(ByRef pstrTable() As String)
    Dim x                       As Long
    
    ReDim strTableString(0 To UBound(pstrTable))
    For x = 0 To UBound(strTableString) Step 1
        strTableString(x) = pstrTable(x)
    Next x
    lngCount = UBound(strTableString) + 1
    enmTableType = VT_String
End Sub
Friend Function GetTableString(ByRef pstrTable() As String) As Long
    Dim x                       As Long
    
    For x = 0 To UBound(pstrTable) Step 1
        pstrTable(x) = strTableString(x)
    Next x
    GetTableString = x
End Function

Friend Sub SetTableLong(ByRef plngTable() As Long)
    Dim x                       As Long
    
    ReDim lngTableLong(0 To UBound(plngTable))
    For x = 0 To UBound(lngTableLong) Step 1
        lngTableLong(x) = plngTable(x)
    Next x
    lngCount = UBound(lngTableLong) + 1
    enmTableType = VT_Long
End Sub
Friend Function GetTableLong(ByRef plngTable() As Long) As Long
    Dim x                       As Long
    
    For x = 0 To UBound(plngTable) Step 1
        plngTable(x) = lngTableLong(x)
    Next x
    GetTableLong = x
End Function

Friend Sub SetTableInt(ByRef pintTable() As Integer)
    Dim x                       As Long
    
    ReDim intTableInt(0 To UBound(pintTable()))
    For x = 0 To UBound(intTableInt) Step 1
        intTableInt(x) = pintTable(x)
    Next x

    lngCount = UBound(intTableInt) + 1
    enmTableType = VT_Int
End Sub
Friend Function GetTableInt(ByRef pintTable() As Integer) As Long
    Dim x                       As Long
    
    For x = 0 To UBound(pintTable) Step 1
        pintTable(x) = intTableInt(x)
    Next x
    GetTableInt = x
End Function

Private Sub Class_Terminate()
    Call Clear
End Sub

Private Function GetValue(ByVal plngIndex As Long) As Variant
    Select Case enmTableType
        Case TableType_ENUM.VT_Double:
            GetValue = dblTableDouble(plngIndex)
        Case TableType_ENUM.VT_String:
            GetValue = strTableString(plngIndex)
        Case TableType_ENUM.VT_Long:
            GetValue = lngTableLong(plngIndex)
        Case TableType_ENUM.VT_Int:
            GetValue = intTableInt(plngIndex)
    End Select
    
End Function
