VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBBSortContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

' VB-CONFIGURATION
Option Compare Binary
Option Explicit
Option Base 0


' CONSTANTS(PRIVATE)
Private Const BABERR = vbError + &HBAB
Private Const VAREMPTY = 0&
Private Const NUL& = 0&


' ENUMERATIONS(PUBLIC)
Public Enum Sort_ENUM
    S_Ascending
    S_descending
    S_none
End Enum

Private Enum TableType_ENUM
    VT_Double
    VT_String
    VT_Long
    VT_Int
End Enum


' VARIABLES(PRIVATE)
Private objBBSort()                         As clsBBSort
Private lngCount                            As Long
Private enmSortingStyleAllColumns           As Sort_ENUM


' PROPERTYS(PUBLIC/FRIEND)
Public Property Let SortingStyleAllColumns(ByVal penmSorting As Sort_ENUM)
    Dim x                       As Long
    For x = 0 To lngCount - 1 Step 1
        objBBSort(x).SortingStyle = penmSorting
    Next x
    
End Property
Public Property Get SortingStyleAllColumns() As Sort_ENUM
    SortingStyleAllColumns = enmSortingStyleAllColumns
End Property
Public Property Let SortingStyleColumn(ByVal plngIndex As Long, penmSortingStyle As Sort_ENUM)
    objBBSort(plngIndex).SortingStyle = penmSortingStyle
End Property
Public Property Get SortingStyleColumn(ByVal plngIndex As Long) As Sort_ENUM
    SortingStyleColumn = objBBSort(plngIndex).SortingStyle
End Property

' FUNCTIONS/SUBS
' PUBLIC

Public Sub Clear()
'Auflsen von Zirkelbezgen
    Dim x                       As Long

    For x = 0 To lngCount - 1
        Set objBBSort(x) = Nothing
    Next x
End Sub

Public Sub Go()
    objBBSort(0).SortFrom = 0
    objBBSort(0).SortTo = objBBSort(0).Count - 1
    Call objBBSort(0).Go
End Sub

Public Sub PushDouble(ByRef pdblArray() As Double)
    Call RegisterNewClass
    Call objBBSort(lngCount - 1).SetTableDouble(pdblArray())
End Sub
Public Function PopDouble(ByRef pdblArray() As Double) As Long
    lngCount = lngCount - 1
    PopDouble = objBBSort(lngCount).GetTableDouble(pdblArray())
    Set objBBSort(lngCount) = Nothing
End Function

Public Sub PushString(ByRef pstrArray() As String)
    Call RegisterNewClass
    Call objBBSort(lngCount - 1).SetTableString(pstrArray())
End Sub
Public Function PopString(ByRef pstrArray() As String) As Long
    lngCount = lngCount - 1
    PopString = objBBSort(lngCount).GetTableString(pstrArray())
    Set objBBSort(lngCount) = Nothing
End Function

Public Sub PushLong(ByRef plngArray() As Long)
    Call RegisterNewClass
    Call objBBSort(lngCount - 1).SetTableLong(plngArray())
End Sub
Public Function PopLong(ByRef plngArray() As Long) As Long
    lngCount = lngCount - 1
    PopLong = objBBSort(lngCount).GetTableLong(plngArray())
    Set objBBSort(lngCount) = Nothing
End Function

Public Sub PushInt(ByRef pintArray() As Integer)
    Call RegisterNewClass
    Call objBBSort(lngCount - 1).SetTableInt(pintArray())
End Sub
Public Function PopInt(ByRef pintArray() As Integer) As Long
    lngCount = lngCount - 1
    PopInt = objBBSort(lngCount).GetTableInt(pintArray())
    Set objBBSort(lngCount) = Nothing
End Function

Friend Sub DoSwapValue(ByVal ClassCallerID As Long, ByVal FromPosition As Long, _
    ByVal ToPosition As Long)
    
    Dim x                       As Long
    For x = 0 To lngCount - 1 Step 1
        If ClassCallerID <> x Then
            Call objBBSort(x).Swap(FromPosition, ToPosition)
        End If
    Next x
End Sub

Friend Sub DoSort(ByVal ClassCallerID As Long, ByVal FromPosition As Long, _
    ByVal ToPosition As Long)
    
    If ClassCallerID < lngCount - 1 Then
        objBBSort(ClassCallerID + 1).SortFrom = FromPosition
        objBBSort(ClassCallerID + 1).SortTo = ToPosition
        Call objBBSort(ClassCallerID + 1).Go
    End If
End Sub

' PRIVATE/FRIEND
Private Sub Class_Terminate()
    Call Clear
End Sub

Private Sub RegisterNewClass()
    
    ReDim Preserve objBBSort(0 To lngCount)
    Set objBBSort(lngCount) = New clsBBSort
    Set objBBSort(lngCount).BBparent = Me
        objBBSort(lngCount).ClassID = lngCount
    lngCount = lngCount + 1

End Sub
